#ifndef SPODS_HepMCImporter
#define SPODS_HepMCImporter

// SPODS--Simple Physics Object based Detector Simulation
// Copyright (C) 2011, 2012, 2013 Justin Hugon

#include "HepMC/IO_GenEvent.h"
#include <string>

class TClonesArray;
class TObjArray;

namespace SPODS 
{
class HepMCImporter
{
protected:
   HepMC::IO_GenEvent      fIO_GenEvent;     //! The IO_GenEvent instance
   HepMC::GenEvent         fCurrentGenEvent;     //! The GenEvent instance
   int                   fNumberOfParticles;  //! Number of particles
   bool			   fDoneReading;
public:
   HepMCImporter(const std::string inFileName);
   HepMCImporter*   Instance();

   // Interface
   void            GenerateEvent();
   int           ImportParticles(TClonesArray *particles, const char* option="");
   int                   GetN() const {return fNumberOfParticles;};
   bool                   Done() const {return fDoneReading;};
   int           GetNMPI() const;
   double        GetWeight() const;

};

}
#endif

