#ifndef SPODS_YamlReader
#define SPODS_YamlReader

// SPODS--Simple Physics Object based Detector Simulation
// Copyright (C) 2011, 2012, 2013 Justin Hugon

#include <fstream>
#include <string>
#include <utility>
#include <yaml-cpp/yaml.h>

namespace SPODS 
{
class YamlReader
{
private:
   std::string filename;
   std::ifstream fin;
   YAML::Parser parser;
   YAML::Node doc;
public:
   YamlReader(std::string filename);
   bool GetNextDoc();
   std::string GetValue(std::string);
   std::vector<std::pair<float,float> > GetVectorOfPairs(std::string);
   std::vector<float> GetVectorOfFloats(std::string);
};

}
#endif


