// SPODS--Simple Physics Object based Detector Simulation
// Copyright (C) 2011, 2012, 2013 Justin Hugon

#include <fstream>
#include <yaml-cpp/yaml.h>
#include <iostream>
#include <utility>
#include "YamlReader.h"
#include "YamlConfig.h"

int main()
{
  /*
  std::ifstream fin("test.yaml");
  YAML::Parser parser(fin);

  YAML::Node doc;
  while (parser.GetNextDocument(doc))
  {
    std::cout << "Begin Document" << std::endl;
    for(YAML::Iterator it = doc.begin(); it != doc.end(); ++it)
    {
	std::string key, value;
	it.first() >> key;
	it.second() >> value;
	std::cout << key << "\t" << value << std::endl;
    }
    std::cout << "End Document" << std::endl;
    if (const YAML::Node *value = doc.FindValue("name"))
    {
	std::string name;
	*value >> name;
	std::cout << "name is " << name << std::endl;
    }
    else
    {
	std::cout << "name doesn't exist\n";
    }

  }
  */

  SPODS::YamlReader yReaderSilly("cmsConfig.yaml");
  std::cout << "nEventsMax is " << yReaderSilly.GetValue("maxEvents") << std::endl;

//YamlReader::GetVectorOfFloats(std::string key)
//YamlReader::GetVectorOfFloats(std::string key)
    std::cout << "VectorOfPairs: " << std::endl;
  //std::vector< std::pair<float,float> > tmpVectorPair(0,std::make_pair(1.1,2.2));
  std::vector< std::pair<float,float> > tmpVectorPair = 
		yReaderSilly.GetVectorOfPairs("muonResEtaRanges");
  for(std::vector< std::pair<float,float> >::iterator tmpPair=tmpVectorPair.begin();
		tmpPair != tmpVectorPair.end();tmpPair++)
  {
    std::cout << "Pair: " << tmpPair->first << ", "<< tmpPair->second << std::endl;
  }

  std::vector< float > tmpVector = 
		yReaderSilly.GetVectorOfFloats("muonResConstTerm");
  for(std::vector<float>::iterator tmp=tmpVector.begin();
		tmp != tmpVector.end();tmp++)
  {
    std::cout << "float: " << *tmp << std::endl;
  }

  SPODS::YamlConfig* config = new SPODS::YamlConfig("cmsConfig.yaml");
  std::cout << "maxPhotons is " << config->maxPhotons << std::endl;
  std::cout << "etaMuonMax is " << config->etaMuonMax << std::endl;
  std::cout << "ptJetMin is " << config->ptJetMin << std::endl;
  std::cout << "ptMuonMin is " << config->ptMuonMin << std::endl;
  std::cout << "jetAlg is " << config->jetAlg << std::endl;
  std::cout << "jetAlgR is " << config->jetAlgR << std::endl;
  
  return 0;
}
